/// <reference types="@tarojs/taro" />

declare module '*.png';
declare module '*.gif';
declare module '*.jpg';
declare module '*.jpeg';
declare module '*.svg';
declare module '*.css';
declare module '*.less';
declare module '*.scss';
// declare module '*.sass';
declare module '*.styl';

declare namespace NodeJS {
  interface ProcessEnv {
    TARO_ENV: 'weapp' | 'swan' | 'alipay' | 'h5' | 'rn' | 'tt' | 'quickapp' | 'qq' | 'jd'
  }
}

declare namespace JSX {
  interface IntrinsicElements {
    custom: React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> & { props?: any }

    calendar: React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement>
  }
}

declare const wx

declare namespace Taro {
  interface TaroStatic {
    $global: any
  }
}

type CustomPropsType = {
  adpId: number
  width?: number
  closeIcon?: boolean
  onEmitOpenMiniProgram(appId: string, path: string, extraData: { pqtId?: string }): void
  onError?(code: number): void
  onLoad?(): void
  onClose?(): void
}

type ConfigType = {
  header?: {},
  method?: 'GET' | 'POST',
  timeout?: number
}

type DataType = {
  [key: string]: any
  baseInfo?: object
}

type HttpInstanceType = {
  get(url: string, data?: {}, config?: ConfigType): Promise<any>
  post(url: string, data?: {}, config?: ConfigType): Promise<any>
}

interface RequestType {
  code: number,
  data: any,
  msg: string
}
